<?php

namespace App\Http\Controllers\Admin;
use Image;
use App\ProfilWebsite;
use Illuminate\Validation\Rule;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ProfilWebsiteController extends Controller
{
    public function index()
    {
      $data = ProfilWebsite::first();
      return view('pages.admin.profil_website',compact('data'));
    }

    public function save(Request $request)
    {
      $id = intval($request->input('id_website'));
			$nama_website=$request->input('nama_website');
			$facebook_website=$request->input('facebook_website');
			$instagram_website=$request->input('instagram_website');
			$wa_website=$request->input('wa_website');
			$telp_website=$request->input('telp_website');
			$deskripsi_website=$request->input('deskripsi_website');
			$foto_file = $request->file('foto_file');
			$foto_url = $request->input('foto_url');

      $validations = [
				'nama_website' => 'required',
				'facebook_website' => 'required',
				'instagram_website' => 'required',
				'wa_website' => 'required|numeric',
				'telp_website' => 'required|numeric',
				'deskripsi_website' => 'required',
				];
      $this->validateWith($validations, $request);

      $pesan_sukses = 'Data kategori berhasil di ubah';
      $profil_website = ProfilWebsite::where('id_website',$id)->first();
      if(is_null($profil_website)){
        return response()->json(['message' => 'Data tidak ada']);
      }

      if(isset($foto_file)){
        $filename_gambar = time().".".$foto_file->getClientOriginalExtension();
        $foto_file->storeAs('public/assets/logo_website',$filename_gambar);
        $path_gambar = public_path('storage/assets/logo_website/'.$filename_gambar);
        $img_gambar =Image::make($foto_file)->resize(270,270)->save($path_gambar);
        $profil_website->foto = 'assets/logo_website/'.$filename_gambar;
      }else{
        $rr=explode('storage/',$foto_url);
        $profil_website->foto=$rr[1];
      }

      $profil_website->nama_website = $nama_website;
      $profil_website->email_website = $email_website;
      $profil_website->facebook_website = $facebook_website;
      $profil_website->instagram_website = $instagram_website;
      $profil_website->wa_website = $wa_website;
      $profil_website->telp_website = $telp_website;
      $profil_website->deskripsi_website = $deskripsi_website;
      $profil_website->save();
      
      return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
    }
}
