<?php

namespace App\Http\Controllers\Admin;

use Image;
use App\City;
use App\Toko;
use App\Produk;
use DataTables;
use App\Province;
use Illuminate\Support\Str;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use App\Http\Controllers\Controller;

class TokoController extends Controller
{
  public function index()
  {
      return view('pages.admin.toko');
  }

  public function indexDetailToko(Request $request,$slug)
  {
    $toko = Toko::where('slug_toko',$slug)->first();
    return view('pages.admin.toko-produk-detail',compact('toko'));
  }

  public function getListProduk(Request $request,$id)
  {
    if ($request->ajax()) {
      $data = Produk::select('produk.*','toko.*')
      ->join('toko','toko.id_toko','=','produk.id_toko')
      ->where('produk.status_produk','<>','2')->where('produk.id_toko',$id)->orderByDesc('produk.id_produk')->get();
      return Datatables::of($data)
        ->addIndexColumn()
        ->addColumn('action', function($data){
          $actionBtn = '<a href="javascript:void(0)" data-id="'.$data->id_produk.'" class="btn btn-success btn-sm btn-item-edit"><i class="fa fa-edit"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_produk.'" class="btn btn-danger btn-item-delete btn-sm"><i class="fa fa-trash"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_produk.'" class="btn btn-primary btn-item-approve btn-sm"><i class="fas fa-lock"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_produk.'" class="btn btn-primary btn-item-non-approve btn-sm"><i class="fas fa-unlock"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_produk.'" class="btn btn-danger btn-item-blokir btn-sm"><i class="fas fa-times"></i></a>';
          return $actionBtn;
        })
        ->editColumn('info_produk', function($data) {
          return '<div class="d-flex">
                  <img src="/storage/assets/produk/'.$data->foto_1_produk.'" class="img img-thumbnail" style="width:100px">
                  <div style="margin-left:5px">
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px"><span class="badge bg-primary text-white">'.$data->nama_toko.'</span></div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px"><b style="font-weight:bolder">'.$data->nama_produk.'</b></div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">'.$data->nama_kategori.'</div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">Min Order:'.$data->min_order_produk.'</div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">Rp'.number_format($data->harga_produk,0,',','.').'</div>
                    <div>'.($data->status_produk=='0'?'<span class="badge bg-danger text-white">Tidak Aktif</span>':($data->status_produk=='1'?'<span class="badge bg-success text-white">Aktif</span>':($data->status_produk=='3'?'<span class="badge bg-danger text-white">Blokir</span>':''))).'</div>
                  </div>
                </div>
                ';
        })
        // ->editColumn('tgl_upload_produk', function($data) {
        //   return date('d-m-Y',strtotime($data->tgl_upload_produk));
        // })
        ->editColumn('stok_produk', function($data) {
          return number_format($data->stok_produk,0,',','.');
        })
        ->editColumn('harga_produk', function($data) {
          return number_format($data->harga_produk,0,',','.');
        })
        ->rawColumns(['action','info_produk'])
        ->make(true);
    }
  }

  public function getList(Request $request)
  {
    if ($request->ajax()) {
      $data = Toko::select('toko.*','provinces.province as nm_provinsi','cities.city_name as nm_kota')
      ->join('provinces','provinces.id','=','toko.id_province')
      ->join('cities','cities.id','=','toko.id_city')
      ->where('status_toko','<>','2')->orderByDesc('id_toko')->get();
      return Datatables::of($data)
        ->addIndexColumn()
        ->addColumn('action', function($data){
          $actionBtn = '<a href="javascript:void(0)" data-id="'.$data->id_toko.'" class="btn btn-success btn-sm btn-item-edit"><i class="fa fa-edit"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_toko.'" class="btn btn-danger btn-item-delete btn-sm"><i class="fa fa-trash"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_toko.'" class="btn btn-primary btn-item-approve btn-sm"><i class="fas fa-lock"></i></a> <a href="/admin/toko/'.$data->slug_toko.'" class="btn btn-info btn-sm"><i class="fas fa-store"></i></a>';
          return $actionBtn;
        })
        ->editColumn('info_toko', function($data) {
          return '<div class="d-flex">
                  <img src="'.(is_null($data->logo_toko)?"/img/image-default.png":"/storage/assets/logo_toko/'.$data->logo_toko.'").'" class="img img-thumbnail" style="width:100px">
                  <div style="margin-left:5px">
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px"><span class="badge bg-primary text-white">'.$data->nama_toko.'</span></div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px"><b style="font-weight:bolder">'.$data->telp_toko.'</b></div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">'.$data->nm_provinsi.' '.$data->nm_kota.'</div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">'.date('d-m-Y',strtotime($data->tgl_buka_toko)).'</div>
                  </div>
                </div>
                ';
        })
        ->editColumn('status_toko_n', function($data) {
          return '<div>'.($data->status_toko=='0'?'<span class="badge bg-success text-white">Aktif</span>':($data->status_toko=='1'?'<div class="badge bg-danger text-white">Non Aktif</div><div>'.$data->alasan_non_aktif.'</div>':'')).'</div>';
        })
        ->rawColumns(['action','info_toko','status_toko_n'])
        ->make(true);
    }
  }

  public function provincesChange(Request $request)
  {
    $regencies = City::where('province_id', $request->get('id'))
                ->pluck('city_name', 'id');
    return response()->json($regencies);
  }

  public function detail($id)
  {
    $input_readonly = [];
    if($id==0){
    $data = (Object)[
        'id_toko'=>$id,
        'nama_toko'=>'',
        'telp_toko'=>'',
        'deskripsi_toko'=>'',
        'catatan_toko'=>'',
        'id_province'=>'',
        'id_city'=>'',
        'detail_alamat'=>'',
        'logo_toko'=>'',
        'alasan_non_aktif'=>'',
        'status_toko'=>'0'
    ];
    }else{
    $data = Toko::select('*')->where('id_toko',$id)->first();
    if(is_null($data)){
      return response()->json(['error' => 'Data Toko tidak ada'], 403);
    }
    }
    if($data->status_toko!='0'){
      $input_readonly = ['nama_toko'];
    }
    $data->provinces = Province::get();
    $data->cities = City::get();
    return view('pages.admin.toko-detail', compact('data','input_readonly'));
  }

  public function save(Request $request)
  {
    $id = intval($request->input('id_toko'));
    $nama_toko=$request->input('nama_toko');
    $id_user=$request->input('id_user');
    $tgl_buka_toko=$request->input('tgl_buka_toko');
    $telp_toko = $request->input('telp_toko');
    $provinsi = $request->input('provinsi');
    $kota = $request->input('kota');
    $detail_alamat = $request->input('detail_alamat');
    $deskripsi_toko = $request->input('deskripsi_toko');
    $catatan_toko = $request->input('catatan_toko');
    $status_toko = $request->input('status_toko');
    $alasan_non_aktif = $request->input('alasan_non_aktif');
    $foto_file = $request->file('foto_file');
    $foto_url = $request->input('foto_url');

    $validations = [
      'nama_toko' => ['Required',Rule::unique('toko','nama_toko')->where(function($q){
          return $q->where('status_toko','!=','2');
      })->ignore($id,'id_toko')],
      'telp_toko' => 'required|numeric',
      'provinsi' => 'required',
      'kota' => 'required',
      'detail_alamat' => 'required',
    ];
    if($status_toko=='1'){
      $validations['alasan_non_aktif'] = ['required'];
    }
    $this->validateWith($validations, $request);

    if($id==0){
      $pesan_sukses = 'Data toko berhasil di tambahkan';
      $toko = new Toko;
    }else{
      $pesan_sukses = 'Data toko berhasil di ubah';
      $toko = Toko::where('id_toko',$id)->first();
      $VALUE_HISTORY = 'Edit';
      if(is_null($toko)){
        return response()->json(['message' => 'Data tidak ada']);
      }
      if($toko->status_toko=='2'){
        return response()->json(['message' => 'Data sudah di Hapus']);
      }
    }

    if(isset($foto_file)){
      $filename_gambar = time().".".$foto_file->getClientOriginalExtension();
      $foto_file->storeAs('public/assets/logo_toko',$filename_gambar);
      $path_gambar = public_path('storage/assets/logo_toko/'.$filename_gambar);
      $img_gambar =Image::make($foto_file)->resize(100,100)->save($path_gambar);
      $kategori->logo_toko = 'assets/logo_toko/'.$filename_gambar;
    }else{
      $toko->logo_toko=NULL;
    }

    $toko->nama_toko = $nama_toko;
    $toko->slug_toko = \Str::slug($nama_toko);
    $toko->telp_toko = $telp_toko;
    $toko->id_province = $provinsi;
    $toko->id_city = $kota;
    $toko->detail_alamat = $detail_alamat;
    $toko->deskripsi_toko = $deskripsi_toko;
    $toko->catatan_toko = $catatan_toko;
    $toko->status_toko = $status_toko;
    if($status_toko=='1'){
      $toko->alasan_non_aktif = $alasan_non_aktif;
    }else{
      $toko->alasan_non_aktif = NULL;
    }
    $toko->id_user = $id_user;
    $toko->tgl_buka_toko = $tgl_buka_toko;
    $toko->save();
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function del(Request $request)
  {
    $id = intval($request->input('id'));
    $toko = Toko::where('id_toko',$id)->first();
    if(is_null($toko)){
    return response()->json(['message' => 'Data tidak ada']);
    }
    if($toko->status_toko=='0'){
      return response()->json(['message' => 'Data sudah aktif']);
      }
    if($toko->status_toko=='2'){
    return response()->json(['message' => 'Data sudah di Hapus']);
    }

    $pesan_sukses = 'Data toko berhasil di Hapus';
    $toko->status_toko = '2';
    $toko->save();
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function app(Request $request)
  {
    $id = intval($request->input('id'));
    $toko = Toko::where('id_toko',$id)->first();
    if(is_null($toko)){
      return response()->json(['message' => 'Data tidak ada']);
    }
    if($toko->status_toko=='0'){
      return response()->json(['message' => 'Data sudah Aktif']);
    }
    if($toko->status_toko=='2'){
      return response()->json(['message' => 'Data sudah di Hapus']);
    }

    $pesan_sukses = 'Data toko berhasil di Aktifkan:';
    $toko->status_toko = '0';
    $toko->alasan_non_aktif = NULL;
    $toko->save();
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }
}
