<?php

namespace App\Http\Controllers\Auth;

use App\UserAdmin;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;

class AdminLoginController extends Controller
{
  public function __construct()
    {
        $this->middleware('guest:admin',['except' => ['logoutAdmin']]);
    }

  public function index()
  {
    return view('auth.login-admin');
  }

  public function postLoginAdmin(Request $request)
  {
    $user_login = false;
		$user = UserAdmin::where('username', $request->username)
                ->where('STATUS_USER','1')
                ->first();
		if(!is_null($user)){
      if (Hash::check($request->password, $user->password)) {
        Auth::guard('admin')->login($user);
        $user_login = true;
      }
    }
        
    if($user_login){
        return response()->json(['status'=>'SUCCESS','message' => 'Berhasil Login', 'redirect_url' => '/admin/dashboard']);
    }else{
        return response()->json(['status'=>'ERROR','message' => 'Username atau Password salah']);
    }
  }

  public function logoutAdmin()
  {
      Auth::guard('admin')->logout();
      return response()->json(['status'=>'SUCCESS','message' => 'Berhasil Logout', 'redirect_url' => '/login-admin']);
  }
}
