<?php

namespace App\Http\Controllers\Auth;

use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use App\Providers\RouteServiceProvider;
use Illuminate\Foundation\Auth\AuthenticatesUsers;

class LoginController extends Controller
{
    /*
    |--------------------------------------------------------------------------
    | Login Controller
    |--------------------------------------------------------------------------
    |
    | This controller handles authenticating users for the application and
    | redirecting them to your home screen. The controller uses a trait
    | to conveniently provide its functionality to your applications.
    |
    */

    use AuthenticatesUsers;

    /**
     * Where to redirect users after login.
     *
     * @var string
     */
    protected $redirectTo = RouteServiceProvider::HOME;

    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('guest')->except(['logout','logoutUser']);
    }

    protected function validateLogin(Request $request)
    {
        $data_users = DB::Table('users')->where('email','=',$request->email)->first();
        $validations = [
            'email' => ['required','string',function($attribute, $value, $fail) use($data_users){
                $err_txt = '';
                
                if(is_null($data_users)){
                    $err_txt = 'Maaf email kamu belum terdaftar';
                }else{
                if($data_users->status_user=='0'){
                    $err_txt = 'Silakan aktivasi di email anda.'." ".'<a href="'.url('register/confirm/resend/'.$value).'" class="btn btn-sm btn-default p-0">Kirim Ulang</a>';
                }
                }
                if($err_txt!=''){
                    $fail($err_txt);
                }
            }],
            'password' => ['required','string',function($attribute, $value, $fail) use($data_users){
                $err_txt = '';
                // if($value==''){
                //     $err_txt = 'Password harus diisi.';
                // }
                if(!is_null($data_users)){
                    if (!Hash::check($value, $data_users->password)) {
                        $err_txt = 'Maaf password anda salah.';
                    }
                }
                if($err_txt!=''){
                    $fail($err_txt);
                }
            }],
        ];
        $this->validateWith($validations, $request);
    }

    public function logoutUser()
    {
        Auth::guard('web')->logout();
        return redirect()->route('home');
    }
}
