<?php

namespace App\Http\Controllers;

use Image;
use App\Bank;
use App\Cart;
use App\Produk;
use DataTables;
use App\Kategori;
use Illuminate\Support\Str;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;

class CartController extends Controller
{
  public function indexCart()
  {
    return view('pages.cart');
  }

  public function cartSave(Request $request)
  {
    $id_toko = intval($request->input('id_toko'));
    $qty = intval($request->input('qty'));
    $id_produk = intval($request->input('id_produk'));
    
    // Cek QTY
    if($qty == '' || $qty == '0' || $qty == 'NaN'){
      return response()->json(['message' => 'Data tidak boleh kosong atau 0']);
    }
    //Cek Produk Toko
    $produk = Produk::where('id_toko',$id_toko)->where('id_produk',$id_produk)->first();
    if(is_null($produk)){
      return response()->json(['message' => 'Produk tidak ditemukan']);
    }

    $pesan_sukses = 'Produk berhasil di tambahkan ke keranjang';
    $cart = Cart::where('id_user',Auth::guard('web')->user()->id)->where('id_produk',$produk->id_produk)->where('id_toko',$produk->id_toko)->first();
    if(!is_null($cart)){
      $cart->increment('qty',$qty);
    }else{
      $cart = new Cart;
      $cart->id_user = Auth::guard('web')->user()->id;
      $cart->id_produk = $produk->id_produk;
      $cart->id_toko = $produk->id_toko;
      $cart->qty = $qty;
      $cart->save();
    }

    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function del(Request $request)
  {
    $id = intval($request->input('id'));
    $cart = Cart::where('id_cart',$id)->first();
    if(is_null($cart)){
    return response()->json(['message' => 'Data tidak ada']);
    }

    $pesan_sukses = 'produk berhasil di Hapus';
    $cart->delete();
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function getCart(Request $request)
  {
    $carts = Cart::select('cart.*','produk.*','cities.city_name as kota_toko','cities.id as id_kota','toko.*')
    // $carts = Cart::select('cart.*','produk.*','toko.*')
    ->join('produk','produk.id_produk','=','cart.id_produk')
    ->join('toko','toko.id_toko','=','cart.id_toko')
    ->join('cities','toko.id_city','=','cities.id')
    ->where('cart.id_user',Auth::guard('web')->user()->id)
    ->orderBy('cart.id_toko','desc')
    ->get();
      $lasttoko='';
      $process = [];
      $produk = null;
      $i = -1;
      $berat=0;
      foreach($carts as $r){
          if($r->nama_toko !== $lasttoko){
              if($i>-1){
                  $process[$i]['produk']=$produk;
                  $process[$i]['berat']=$berat;
              }
              $i++;
              $produk = [];
              $process[$i]=['nama_toko'=>$r->nama_toko,'kota_toko'=>$r->kota_toko,'id_kota'=>$r->id_kota,'berat'=>0,'id_toko'=>$r->id_toko,'produk'=>[]];
              $lasttoko=$r->nama_toko;
              $berat=0;
          }
          $produk[] = $r;
          $berat+= $r->berat_produk*$r->qty;
      }
      if(count($carts)>0){
        $process[$i]['produk']=$produk;
        $process[$i]['berat']=$berat;
      }
      // dd($process);
    return response()->json(['status'=>'SUCCESS','result' => $process]);
  }

  public function qtyPlus(Request $request)
  {
    $id = intval($request->input('id'));
    $cart = Cart::where('id_cart',$id)->first();
    if(is_null($cart)){
    return response()->json(['message' => 'Data tidak ada']);
    }

    $pesan_sukses = '';
    $cart->increment('qty');
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function qtyMinus(Request $request)
  {
    $id = intval($request->input('id'));
    $cart = Cart::where('id_cart',$id)->first();
    if(is_null($cart)){
    return response()->json(['message' => 'Data tidak ada']);
    }

    $pesan_sukses = '';
    $cart->decrement('qty');
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function beliCheckout()
  {
    $bank = Bank::where('status_bank','1')->get();
    return view('pages.cart-shipment',compact('bank'));
  }
}
