<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\DB;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Routing\Controller as BaseController;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Foundation\Auth\Access\AuthorizesRequests;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;

    public function replace_save_images($str,$filename_prefix='',$save_path="assets/images/"){
        $pos_start = 0;
        $imgs = [];
        do{
            $pos_start=stripos($str,'src="data:image/',$pos_start);
            if($pos_start!==false){
                $pos_start_src = stripos($str,'"',$pos_start)+1;
                $pos_end_src = stripos($str,'"',$pos_start_src)+1;
                $src_img = substr($str,$pos_start_src,$pos_end_src-$pos_start_src);
                $pos_base64 = stripos($str,';base64,',$pos_start_src);
                $img_type = substr($str,$pos_start_src,$pos_base64-$pos_start_src);
                $img_data = substr($str,($pos_base64+strlen(';base64,')),$pos_end_src-($pos_base64+strlen(';base64,'))-1);
                $ext = '.png';
                if($img_type=='image/png'){
                    $ext = '.png';
                }else if($img_type=='image/jpeg'){
                    $ext = '.jpg';
                }
                $filename=($filename_prefix!=''?$filename_prefix.'-':'').\Str::random(10).'.'.microtime(true).$ext;
                \File::put(storage_path('app/public/'). $save_path . $filename, base64_decode($img_data));
                //$imgs[]=['type'=>$img_type,'data'=>$img_data,'path'=>$filename];
                $str = substr_replace($str,'/storage/'.$save_path.$filename,$pos_start_src,$pos_end_src-$pos_start_src-1);
            }
        }while($pos_start!==false);
        return $str;
    }

    protected function generateBukti($jenis, $tgl)
    {
        $bulan = date('m',strtotime($tgl));
        $tahun = date('Y',strtotime($tgl));
        $arr_jenis = [
            'order'=>['code'=>'TRX-FISH','table'=>'order','tgl'=>'tgl_order','bukti'=>'kode_order'],
        ];
        $code = $arr_jenis[$jenis]['code'];
        $table = $arr_jenis[$jenis]['table'];
        $tgl = $arr_jenis[$jenis]['tgl'];
        $bukti = $arr_jenis[$jenis]['bukti'];

        $data = DB::Table($table)
            ->select(DB::raw("CONCAT(LPAD(COUNT(*)+1,5,'0'),'/$code/$bulan/$tahun') AS bukti"))
            ->where(DB::raw("YEAR(".$tgl.")"),'=',$tahun)
            ->where(DB::raw("MONTH(".$tgl.")"),'=',$bulan)
            ->where($bukti,'!=','')
            ->first();
        return $data->bukti;
    }
}
