<?php

namespace App\Http\Controllers;

use App\Toko;
use App\Produk;
use App\Artikel;
use App\Kategori;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class HomeController extends Controller
{
    public function index()
    {
        $toko = Toko::where('id_user',Auth::guard('web')->user()->id??0)->first();
        $query = Produk::select('produk.*','kategori.nama_kategori','cities.city_name as kota','toko.nama_toko')
        ->join('kategori','kategori.id_kategori','=','produk.id_kategori')
        ->join('toko','toko.id_toko','=','produk.id_toko')
        ->join('cities','toko.id_city','=','cities.id')->where('status_produk','1')->orderBydesc('id_produk');
        if(!is_null($toko)){
            $query->where('toko.id_toko','!=',$toko->id_toko);
        }
        $new_produk = $query->take(4)->get();
        // dd($new_produk);
        $new_artikel = Artikel::where('status_artikel','1')->take(5)->get();
        $kategori = Kategori::where('status_kategori','1')->get();
        return view('pages.home',compact('new_produk','new_artikel','kategori'));
    }

    public function kontakKami()
    {
        return view('pages.kontak-kami');
    }

    public function tentangKami()
    {
        return view('pages.tentang-kami');
    }
}
