<?php

namespace App\Http\Controllers;

use App\Produk;
use App\Kategori;
use Illuminate\Http\Request;

class ProdukController extends Controller
{
    public function index()
    {
        return view('pages.produk-all');
    }

    public function detailProduk($slug)
    {
        // $produk = Produk::where('status_produk','1')->where('slug_produk',$slug)->first();
        $produk = Produk::select('produk.*','kategori.nama_kategori','cities.city_name as kota','toko.nama_toko')
            ->join('kategori','kategori.id_kategori','=','produk.id_kategori')
            ->join('toko','toko.id_toko','=','produk.id_toko')
            ->join('cities','toko.id_city','=','cities.id')
            ->where('status_produk','1')->where('slug_produk',$slug)->first();
        if(is_null($produk)){
            return redirect()->route('home');
        }
        return view('pages.produk-detail',compact('produk'));
    }

    public function produkKategoriDetail($slug)
    {
        if($slug == 'all'){
            $produk = Produk::select('produk.*','kategori.nama_kategori','cities.city_name as kota')
            ->join('kategori','kategori.id_kategori','=','produk.id_kategori')
            ->join('toko','toko.id_toko','=','produk.id_toko')
            ->join('cities','toko.id_city','=','cities.id')
            ->where('status_produk','1')->orderBydesc('id_produk')->paginate(10);
        }else{
            $kategori = Kategori::where('slug_kategori',$slug)->first();
            if(is_null($kategori)){
                return abort(404);
            }
            $produk = Produk::select('produk.*','kategori.nama_kategori','cities.city_name as kota')
            ->join('kategori','kategori.id_kategori','=','produk.id_kategori')
            ->join('toko','toko.id_toko','=','produk.id_toko')
            ->join('cities','toko.id_city','=','cities.id')
            ->where('status_produk','1')->where('produk.id_kategori',$kategori->id_kategori)->orderBydesc('id_produk')->paginate(10);
        }
        return view('pages.produk-all',compact('produk'));
    }
}
