<?php

namespace App\Http\Controllers\Seller;

use App\Toko;
use App\Order;
use App\OrderDetail;
use PDF;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;

class PesananController extends Controller
{
  public function index()
  {
    return view('pages.seller.pesanan');
  }

  public function getListNewOrder(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $order_details = Order::select('order.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi','bank_user.*','order_detail.*','produk.*','order_courier.courier as courier_cour','order_courier.shipping_cost as shipping_cost_cour')
            ->leftJoin('bank_user','bank_user.id_bank_user','=','order.id_bank_user')
            ->join('order_detail','order_detail.id_order','=','order.id_order')
            ->join('order_courier',function($join){
              $join->on('order_courier.id_order','=','order_detail.id_order');
              $join->on('order_courier.id_toko','=','order_detail.id_toko');
              })
            ->join('produk','produk.id_produk','=','order_detail.id_produk')
            ->join('cities','order.id_city','=','cities.id')
            ->join('provinces','order.id_province','=','provinces.id')
            ->where('order_detail.id_toko',$toko->id_toko)
            ->where('order_detail.status_order_detail','0')
            ->where([
              ['order.status_pembayaran','=','3'],
              ['order.status_pengiriman','=','0']
            ])
            // ->orderBy('order.tgl_order','desc')
            ->get();
    $last_kode_order='';
    $process = [];
    $produk = null;
    $i = -1;
    $berat=0;
    foreach($order_details as $r){
        if($r->kode_order !== $last_kode_order){
            if($i>-1){
                $process[$i]['produk']=$produk;
                $process[$i]['berat']=$berat;
            }
            $i++;
            $produk = [];
            $process[$i]=[
              'kode_order'=>$r->kode_order,
              'id_order'=>$r->id_order,
              'id_toko'=>$r->id_toko,
              'kota'=>$r->kota,
              'provinsi'=>$r->provinsi,
              'berat'=>0,
              'kode_pos'=>$r->kode_pos,
              'courier_cour_x'=>$r->courier_cour,
              'shipping_cost_cour_x'=>$r->shipping_cost_cour,
              'tgl_order'=>$r->tgl_order,
              'grand_total_order'=>$r->grand_total_order,
              'nama_penerima'=>$r->nama_penerima,
              'label_alamat'=>$r->label_alamat,
              'detail_alamat'=>$r->detail_alamat,
              'no_hp'=>$r->no_hp,
              'status_order_detail'=>$r->status_order_detail,
              'status_pembayaran'=>$r->status_pembayaran,
              'produk'=>[]
            ];
            $last_kode_order=$r->kode_order;
            $berat=0;
        }
        $produk[] = $r;
        $berat+= $r->berat_produk*$r->qty;
    }
    if(count($order_details)>0){
      $process[$i]['produk']=$produk;
      $process[$i]['berat']=$berat;
    }
    return response()->json(['status'=>'SUCCESS','result' => $process]);
  }

  public function terimaOrder(Request $request)
  {
    $id_order = intval($request->input('id_order'));
    $id_toko = intval($request->input('id_toko'));

    $pesan_sukses = 'Data Order berhasil di terima';
    OrderDetail::where('id_toko',$id_toko)->where('id_order',$id_order)->update(['status_order_detail' => '1']);
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }
  public function tolakOrder(Request $request)
  {
    $id_order = intval($request->input('id_order'));
    $id_toko = intval($request->input('id_toko'));

    $pesan_sukses = 'Data Order berhasil di tolak';
    OrderDetail::where('id_toko',$id_toko)->where('id_order',$id_order)->update(['status_order_detail' => '4']);
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function pesananTerima()
  {
    return view('pages.seller.pesanan-terima');
  }

  public function getListAcceptOrder(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $order_details = Order::select('order.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi','bank_user.*','order_detail.*','produk.*','order_courier.courier as courier_cour','order_courier.shipping_cost as shipping_cost_cour')
            ->leftJoin('bank_user','bank_user.id_bank_user','=','order.id_bank_user')
            ->join('order_detail','order_detail.id_order','=','order.id_order')
            ->join('order_courier',function($join){
              $join->on('order_courier.id_order','=','order_detail.id_order');
              $join->on('order_courier.id_toko','=','order_detail.id_toko');
              })
            ->join('produk','produk.id_produk','=','order_detail.id_produk')
            ->join('cities','order.id_city','=','cities.id')
            ->join('provinces','order.id_province','=','provinces.id')
            ->where('order_detail.id_toko',$toko->id_toko)
            ->where('order_detail.status_order_detail','1')
            ->where([
              ['order.status_pembayaran','=','3'],
              ['order.status_pengiriman','=','0']
            ])
            // ->orderBy('order.tgl_order','desc')
            ->get();
    $last_kode_order='';
    $process = [];
    $produk = null;
    $i = -1;
    $berat=0;
    foreach($order_details as $r){
        if($r->kode_order !== $last_kode_order){
            if($i>-1){
                $process[$i]['produk']=$produk;
                $process[$i]['berat']=$berat;
            }
            $i++;
            $produk = [];
            $process[$i]=[
              'kode_order'=>$r->kode_order,
              'id_order'=>$r->id_order,
              'id_toko'=>$r->id_toko,
              'kota'=>$r->kota,
              'provinsi'=>$r->provinsi,
              'berat'=>0,
              'kode_pos'=>$r->kode_pos,
              'courier_cour_x'=>$r->courier_cour,
              'shipping_cost_cour_x'=>$r->shipping_cost_cour,
              'tgl_order'=>$r->tgl_order,
              'grand_total_order'=>$r->grand_total_order,
              'nama_penerima'=>$r->nama_penerima,
              'label_alamat'=>$r->label_alamat,
              'detail_alamat'=>$r->detail_alamat,
              'no_hp'=>$r->no_hp,
              'status_order_detail'=>$r->status_order_detail,
              'status_pembayaran'=>$r->status_pembayaran,
              'produk'=>[]
            ];
            $last_kode_order=$r->kode_order;
            $berat=0;
        }
        $produk[] = $r;
        $berat+= $r->berat_produk*$r->qty;
    }
    if(count($order_details)>0){
      $process[$i]['produk']=$produk;
      $process[$i]['berat']=$berat;
    }
    return response()->json(['status'=>'SUCCESS','result' => $process]);
  }

  public function pesananTerimaResiDetail(Request $request,$order,$toko)
  {
    $data = (Object)[
      'no_resi'=>'',
      'order'=>$order,
      'toko'=>$toko
    ];
    return view('pages.seller.pesanan-terima-resi', compact('data'));
  }

  public function pesananTerimaResiSave(Request $request)
  {
    $id_order = intval($request->input('id_order'));
    $id_toko = intval($request->input('id_toko'));
    $no_resi=$request->input('no_resi');

    $validations = [
      'no_resi' => 'required',
    ];
    $this->validateWith($validations, $request);

    $pesan_sukses = 'No Resi berhasil di simpan';
    // OrderDetail::where('id_toko',$id_toko)->where('id_order',$id_order)->update(['no_resi' => $no_resi]);
    $details = OrderDetail::where('id_toko',$id_toko)->where('id_order',$id_order)->get();
    foreach ($details as $dt) {
      $dt->status_order_detail = '2';
      $dt->no_resi = $no_resi;
      $dt->save();
    }
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function pesananTerimaCetakLabel(Request $request,$order,$toko)
  {
    $order_to = Order::select('order.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi')
    ->join('cities','order.id_city','=','cities.id')
    ->join('provinces','order.id_province','=','provinces.id')
    ->where('order.id_order',$order)
    ->first();
    $order_from = Toko::select('toko.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi')
    ->join('cities','toko.id_city','=','cities.id')
    ->join('provinces','toko.id_province','=','provinces.id')
    ->where('id_toko',$toko)
    ->first();
    $customPaper = array(0,0,419.52755905,297.63779527);
    $pdf = PDF::loadview('pages/seller/cetak-label',['order_from'=>$order_from,'order_to'=>$order_to])->setPaper($customPaper,'portrait');
    return $pdf->stream();
  }

  public function pesananKirim()
  {
    return view('pages.seller.pesanan-kirim');
  }

  public function getListKirimOrder(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $order_details = Order::select('order.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi','bank_user.*','order_detail.*','produk.*','order_courier.courier as courier_cour','order_courier.shipping_cost as shipping_cost_cour')
            ->leftJoin('bank_user','bank_user.id_bank_user','=','order.id_bank_user')
            ->join('order_detail','order_detail.id_order','=','order.id_order')
            ->join('order_courier',function($join){
              $join->on('order_courier.id_order','=','order_detail.id_order');
              $join->on('order_courier.id_toko','=','order_detail.id_toko');
              })
            ->join('produk','produk.id_produk','=','order_detail.id_produk')
            ->join('cities','order.id_city','=','cities.id')
            ->join('provinces','order.id_province','=','provinces.id')
            ->where('order_detail.id_toko',$toko->id_toko)
            ->where('order_detail.status_order_detail','2')
            ->where([
              ['order.status_pembayaran','=','3'],
              ['order.status_pengiriman','=','0']
            ])
            // ->orderBy('order.tgl_order','desc')
            ->get();
    $last_kode_order='';
    $process = [];
    $produk = null;
    $i = -1;
    $berat=0;
    foreach($order_details as $r){
        if($r->kode_order !== $last_kode_order){
            if($i>-1){
                $process[$i]['produk']=$produk;
                $process[$i]['berat']=$berat;
            }
            $i++;
            $produk = [];
            $process[$i]=[
              'kode_order'=>$r->kode_order,
              'id_order'=>$r->id_order,
              'id_toko'=>$r->id_toko,
              'kota'=>$r->kota,
              'provinsi'=>$r->provinsi,
              'berat'=>0,
              'kode_pos'=>$r->kode_pos,
              'courier_cour_x'=>$r->courier_cour,
              'shipping_cost_cour_x'=>$r->shipping_cost_cour,
              'tgl_order'=>$r->tgl_order,
              'grand_total_order'=>$r->grand_total_order,
              'nama_penerima'=>$r->nama_penerima,
              'label_alamat'=>$r->label_alamat,
              'detail_alamat'=>$r->detail_alamat,
              'no_hp'=>$r->no_hp,
              'status_order_detail'=>$r->status_order_detail,
              'status_pembayaran'=>$r->status_pembayaran,
              'produk'=>[]
            ];
            $last_kode_order=$r->kode_order;
            $berat=0;
        }
        $produk[] = $r;
        $berat+= $r->berat_produk*$r->qty;
    }
    if(count($order_details)>0){
      $process[$i]['produk']=$produk;
      $process[$i]['berat']=$berat;
    }
    return response()->json(['status'=>'SUCCESS','result' => $process]);
  }

  public function pesananTolak()
  {
    return view('pages.seller.pesanan-tolak');
  }

  public function getListRejectOrder(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $order_details = Order::select('order.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi','bank_user.*','order_detail.*','produk.*','order_courier.courier as courier_cour','order_courier.shipping_cost as shipping_cost_cour')
            ->leftJoin('bank_user','bank_user.id_bank_user','=','order.id_bank_user')
            ->join('order_detail','order_detail.id_order','=','order.id_order')
            ->join('order_courier',function($join){
              $join->on('order_courier.id_order','=','order_detail.id_order');
              $join->on('order_courier.id_toko','=','order_detail.id_toko');
              })
            ->join('produk','produk.id_produk','=','order_detail.id_produk')
            ->join('cities','order.id_city','=','cities.id')
            ->join('provinces','order.id_province','=','provinces.id')
            ->where('order_detail.id_toko',$toko->id_toko)
            ->where('order_detail.status_order_detail','4')
            ->where([
              ['order.status_pembayaran','=','3'],
              ['order.status_pengiriman','=','0']
            ])
            // ->orderBy('order.tgl_order','desc')
            ->get();
    $last_kode_order='';
    $process = [];
    $produk = null;
    $i = -1;
    $berat=0;
    foreach($order_details as $r){
        if($r->kode_order !== $last_kode_order){
            if($i>-1){
                $process[$i]['produk']=$produk;
                $process[$i]['berat']=$berat;
            }
            $i++;
            $produk = [];
            $process[$i]=[
              'kode_order'=>$r->kode_order,
              'id_order'=>$r->id_order,
              'id_toko'=>$r->id_toko,
              'kota'=>$r->kota,
              'provinsi'=>$r->provinsi,
              'berat'=>0,
              'kode_pos'=>$r->kode_pos,
              'courier_cour_x'=>$r->courier_cour,
              'shipping_cost_cour_x'=>$r->shipping_cost_cour,
              'tgl_order'=>$r->tgl_order,
              'grand_total_order'=>$r->grand_total_order,
              'nama_penerima'=>$r->nama_penerima,
              'label_alamat'=>$r->label_alamat,
              'detail_alamat'=>$r->detail_alamat,
              'no_hp'=>$r->no_hp,
              'status_order_detail'=>$r->status_order_detail,
              'status_pembayaran'=>$r->status_pembayaran,
              'produk'=>[]
            ];
            $last_kode_order=$r->kode_order;
            $berat=0;
        }
        $produk[] = $r;
        $berat+= $r->berat_produk*$r->qty;
    }
    if(count($order_details)>0){
      $process[$i]['produk']=$produk;
      $process[$i]['berat']=$berat;
    }
    return response()->json(['status'=>'SUCCESS','result' => $process]);
  }

  public function pesananSelesai()
  {
    return view('pages.seller.pesanan-selesai');
  }

  public function getListSelesaiOrder(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $order_details = Order::select('order.*','cities.city_name as kota','cities.postal_code as kode_pos','provinces.province as provinsi','bank_user.*','order_detail.*','produk.*','order_courier.courier as courier_cour','order_courier.shipping_cost as shipping_cost_cour')
            ->leftJoin('bank_user','bank_user.id_bank_user','=','order.id_bank_user')
            ->join('order_detail','order_detail.id_order','=','order.id_order')
            ->join('order_courier',function($join){
              $join->on('order_courier.id_order','=','order_detail.id_order');
              $join->on('order_courier.id_toko','=','order_detail.id_toko');
              })
            ->join('produk','produk.id_produk','=','order_detail.id_produk')
            ->join('cities','order.id_city','=','cities.id')
            ->join('provinces','order.id_province','=','provinces.id')
            ->where('order_detail.id_toko',$toko->id_toko)
            ->where('order_detail.status_order_detail','3')
            ->where([
              ['order.status_pembayaran','=','3'],
              ['order.status_pengiriman','=','0']
            ])
            // ->orderBy('order.tgl_order','desc')
            ->get();
    $last_kode_order='';
    $process = [];
    $produk = null;
    $i = -1;
    $berat=0;
    foreach($order_details as $r){
        if($r->kode_order !== $last_kode_order){
            if($i>-1){
                $process[$i]['produk']=$produk;
                $process[$i]['berat']=$berat;
            }
            $i++;
            $produk = [];
            $process[$i]=[
              'kode_order'=>$r->kode_order,
              'id_order'=>$r->id_order,
              'id_toko'=>$r->id_toko,
              'kota'=>$r->kota,
              'provinsi'=>$r->provinsi,
              'berat'=>0,
              'kode_pos'=>$r->kode_pos,
              'courier_cour_x'=>$r->courier_cour,
              'shipping_cost_cour_x'=>$r->shipping_cost_cour,
              'tgl_order'=>$r->tgl_order,
              'grand_total_order'=>$r->grand_total_order,
              'nama_penerima'=>$r->nama_penerima,
              'label_alamat'=>$r->label_alamat,
              'detail_alamat'=>$r->detail_alamat,
              'no_hp'=>$r->no_hp,
              'status_order_detail'=>$r->status_order_detail,
              'status_pembayaran'=>$r->status_pembayaran,
              'produk'=>[]
            ];
            $last_kode_order=$r->kode_order;
            $berat=0;
        }
        $produk[] = $r;
        $berat+= $r->berat_produk*$r->qty;
    }
    if(count($order_details)>0){
      $process[$i]['produk']=$produk;
      $process[$i]['berat']=$berat;
    }
    return response()->json(['status'=>'SUCCESS','result' => $process]);
  }
}
