<?php

namespace App\Http\Controllers\Seller;

use Image;
use DataTables;
use App\Toko;
use App\BankUser;
use App\Province;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Auth;

class SettingTokoController extends Controller
{
  public function index()
  {
    $provinsi = Province::all();
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    // $rek_user = BankUser::where('id_toko',$toko->id_toko)->first();
    return view('pages.seller.setting-toko',compact('toko','provinsi'));
  }

  public function saveDetailToko(Request $request)
  {
    $id = intval($request->input('id_toko'));
    $nama_toko=$request->input('nama_toko');
    $telp_toko=$request->input('telp_toko');
    $provinsi=$request->input('provinsi');
    $provinsi=$request->input('provinsi');
    $kabupaten=$request->input('kabupaten');
    $detail_alamat=$request->input('detail_alamat');
    $deskripsi_toko=$request->input('deskripsi_toko');
    $catatan_toko=$request->input('catatan_toko');
    $logo_file = $request->file('logo_file');
    $logo_url = $request->input('logo_url');

    $validations = [
      'nama_toko' => ['Required',Rule::unique('toko','nama_toko')->where(function($q){
          return $q->where('status_toko','!=','2');
      })->ignore($id,'id_toko')],
      'telp_toko' => 'required',
      'provinsi' => 'required',
      'kabupaten' => 'required',
      'detail_alamat' => 'required',
      ];
      $this->validateWith($validations, $request);

        $pesan_sukses = 'Data toko berhasil di ubah';
        $toko = Toko::where('id_toko',$id)->first();
        if(is_null($toko)){
          return response()->json(['message' => 'Data tidak ada']);
        }
        if($toko->status_toko=='1'){
          return response()->json(['message' => 'Toko sudah di blokir']);
        }
        if($toko->status_toko=='2'){
          return response()->json(['message' => 'Toko sudah di Hapus']);
        }
      if(isset($logo_file)){
        $filename_gambar = time().".".$logo_file->getClientOriginalExtension();
        $logo_file->storeAs('public/assets/logo_toko',$filename_gambar);
        $path_gambar = public_path('storage/assets/logo_toko/'.$filename_gambar);
        $img_gambar =Image::make($logo_file)->resize(100,100)->save($path_gambar);
        $toko->logo_toko = 'assets/logo_toko/'.$filename_gambar;
      }else{
        $toko->logo_toko=NULL;
      }

      $toko->telp_toko = $telp_toko;
      $toko->id_province = $provinsi;
      $toko->id_city = $kabupaten;
      $toko->detail_alamat = $detail_alamat;
      $toko->deskripsi_toko = $deskripsi_toko??'';
      $toko->catatan_toko = $catatan_toko??'';
      $toko->save();
      
      return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function getListRekening(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    if ($request->ajax()) {
    $data = BankUser::where('id_toko','=',$toko->id_toko)
      ->where('status_bank','<>','2')
      ->orderByDesc('id_bank_user')
      ->get();
    return Datatables::of($data)
      ->addIndexColumn()
      ->addColumn('action', function($data){
        return '<a href="javascript:void(0)" data-id="'.$data->id_bank_user.'" class="btn btn-primary btn-item-edit btn-sm"><i class="fa fa-edit"></i></a> <a href="javascript:void(0)" data-id="'.$data->id_bank_user.'" class="btn btn-danger btn-item-delete btn-sm"><i class="fa fa-trash"></i></a>';
        // return ($data->status_bank=='0'?$actionBtn:'');
      })
      ->editColumn('info_bank', function($data) {
        return '<div>
                  <div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px"><b style="font-weight:bolder">'.$data->nama_bank.'</b></div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">'.$data->nama_pemilik_bank.'</div>
                    <div style="font-size:14px;line-height: 18px;margin-bottom:2px">'.$data->norek_bank.'</div>
                    <div>'.($data->status_bank=='0'?'<a href="javascript:void(0)" data-id="'.$data->id_bank_user.'" class="btn btn-outline-success btn-item-status-utama btn-sm">Jadikan utama</a>':($data->status_bank=='1'?'<span class="badge bg-success">Utama</span>':'')).'</div>
                  </div>
                </div>
                ';
      })
      ->rawColumns(['action','info_bank'])
      ->make(true);
    }
  }

  public function detail($id)
  {
    $input_readonly = [];
    if($id==0){
    $data = (Object)[
        'id_bank_user'=>$id,
        'nama_bank'=>'',
        'nama_pemilik_bank'=>'',
        'norek_bank'=>'',
        'status_bank'=>'0'
      ];
    }else{
      $data = BankUser::where('id_bank_user',$id)->first();
      if(is_null($data)){
        return response()->json(['error' => 'Data bank tidak ada'], 403);
      }
    }
    if($data->status_bank!='0'){
      $input_readonly = ['nama_pemilik_bank','nama_bank','norek_bank'];
    }
    return view('pages.seller.rekening-detail', compact('data','input_readonly'));
  }

  public function saveBankUser(Request $request)
  {
    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $id = intval($request->input('id_bank_user'));
    $nama_pemilik_bank=$request->input('nama_pemilik_bank');
    $nama_bank=$request->input('nama_bank');
    $norek_bank=$request->input('norek_bank');

    $validations = [
      'nama_bank' => ['Required',Rule::unique('bank_user','nama_bank')->where(function($q){
          return $q->where('status_bank','!=','2')->where('id_user',Auth::guard('web')->user()->id);
      })->ignore($id,'id_bank_user')],
      'nama_pemilik_bank' => 'required',
      'norek_bank' => ['Required',Rule::unique('bank_user','norek_bank')->where(function($q){
        return $q->where('status_bank','!=','2');
      })->ignore($id,'id_bank_user')],
      ];
      $this->validateWith($validations, $request);

      $cek_bank = BankUser::where('id_toko',is_null($toko->id_toko)?0:$toko->id_toko)->where('id_user',Auth::guard('web')->user()->id)->get();
      if(count($cek_bank)>=2){
        return response()->json(['message' => 'Data bank kamu sudah melebihi batas']);
      }
      
      if($id==0){
        $pesan_sukses = 'Data bank berhasil di tambahkan';
        $bank_user = new BankUser;
      }else{
        $pesan_sukses = 'Data bank berhasil di ubah';
        $bank_user = BankUser::where('id_bank_user',$id)->first();
        if(is_null($bank_user)){
          return response()->json(['message' => 'Data tidak ada']);
        }
        if($bank_user->status_bank=='1'){
          return response()->json(['message' => 'Data sudah Aktif']);
        }
        if($bank_user->status_bank=='2'){
          return response()->json(['message' => 'Data sudah di hapus']);
        }
      }

      $bank_user->nama_pemilik_bank = $nama_pemilik_bank;
      $bank_user->nama_bank = $nama_bank;
      $bank_user->norek_bank = $norek_bank;
      $bank_user->id_toko = (is_null($toko)?'':$toko->id_toko);
      $bank_user->id_user = Auth::guard('web')->user()->id;
      $bank_user->save();
      return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }

  public function statusUtama(Request $request)
  {
    $id = intval($request->input('id'));
    $bank_user = BankUser::where('id_bank_user',$id)->first();
    if(is_null($bank_user)){
    return response()->json(['message' => 'Data tidak ada']);
    }
    if($bank_user->status_bank=='2'){
    return response()->json(['message' => 'Data sudah di Hapus']);
    }

    $toko = Toko::where('id_user',Auth::guard('web')->user()->id)->first();
    $cek_bank = BankUser::where('status_bank','1')->where('id_toko',$toko->id_toko)->get();
    if(count($cek_bank)>0){
      BankUser::query()->update(['status_bank' => '0']);
    }

    $pesan_sukses = 'Data bank berhasil di jadikan utama';
    $bank_user->status_bank = '1';
    $bank_user->save();
    
    return response()->json(['status'=>'SUCCESS','message'=>'<span class="text-center">'.$pesan_sukses.'</span>']);
  }
}
