<?php

namespace App\Http\Controllers;

use App\City;
use App\Toko;
use App\Province;
use Illuminate\Support\Str;
use Illuminate\Http\Request;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Auth;

class TokoController extends Controller
{
    public function bukaToko()
    {
        $provinsi = Province::all();
        return view('pages.buka-toko',compact('provinsi'));
    }

    public function provincesChange(Request $request)
    {
        $regencies = City::where('province_id', $request->get('id'))
            ->pluck('city_name', 'id');
    
        return response()->json($regencies);
    }

    public function BukaTokoSave(Request $request)
    {
        $nama_toko=$request->input('nama_toko');
        $telp_toko = $request->input('telp_toko');
        $provinsi = $request->input('provinsi');
        $kabupaten = $request->input('kabupaten');
        $detail_alamat = $request->input('detail_alamat');

        $validations = [
        'nama_toko' => ['Required',Rule::unique('toko','nama_toko')->where(function($q){
            return $q->where('status_toko','!=','2');
        })],
        'telp_toko' => 'required|numeric',
        'provinsi' => 'required',
        'kabupaten' => 'required',
        'detail_alamat' => 'required',
        ];
        $this->validateWith($validations, $request);

        $pesan_sukses = 'Toko berhasil di buat';
        $toko = new Toko;

        $toko->nama_toko = $nama_toko;
        $toko->slug_toko = Str::slug($nama_toko,'-');
        $toko->tgl_buka_toko = date('Y-m-d');
        $toko->telp_toko = $telp_toko;
        $toko->id_user = Auth::guard('web')->user()->id;
        $toko->id_province = $provinsi;
        $toko->id_city = $kabupaten;
        $toko->detail_alamat = $detail_alamat;
        $toko->save();

        DB::statement("UPDATE users set toko = 1 where id = '$toko->id_user'");

        return response()->json(['status'=>'SUCCESS','message' => $pesan_sukses, 'redirect_url' => '/seller/dashboard']);
    }
}
